## lomiri-download-manager 0.1.1

=== CMakeLists.txt ===
project(lomiri-download-manager)
cmake_minimum_required(VERSION 3.1)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC -pthread")

# for dh_translations to extract the domain
# (regarding syntax consistency, see http://pad.lv/1181187)
set (GETTEXT_PACKAGE "lomiri-download-manager")
add_definitions(-DI18N_DOMAIN="${GETTEXT_PACKAGE}")

# Standard install paths
include(GNUInstallDirs)

find_package(CoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -coverage" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -coverage" )
  ENABLE_COVERAGE_REPORT(TARGETS ${DIALER_APP})
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

set(QT_INSTALL_QML "${CMAKE_INSTALL_LIBDIR}/qt5/qml")

set(LDM_VERSION_MAJOR 0)
set(LDM_VERSION_MINOR 1)
set(LDM_VERSION_PATCH 1)

file(GLOB_RECURSE I18N_CPP_SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     src/**.cpp)
list(SORT I18N_CPP_SRC_FILES)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
find_package(Boost COMPONENTS log program_options REQUIRED)

find_package(PkgConfig REQUIRED)
pkg_check_modules(DBUS REQUIRED dbus-1)
pkg_check_modules(GLOG REQUIRED libglog)
pkg_check_modules(LOMIRI_API REQUIRED liblomiri-api)

enable_testing()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pipe -std=c++11 -Werror -O2 -Wall -W -D_REENTRANT -fPIC -pedantic -Wextra")
add_definitions("-DNDEBUG")

if(NOT CMAKE_BUILD_TYPE)
	message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
	set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if(cmake_build_type_lower MATCHES relwithdebinfo) # workaround for http://pub    lic.kitware.com/Bug/view.php?id=14696
	add_definitions(-DQT_NO_DEBUG)
endif()

add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(docs)
add_subdirectory(po)

=== tests/common/CMakeLists.txt ===
set(TARGET lomiri-download-manager-test-lib)

set(SOURCES
        base_testcase.cpp
        daemon_testcase.cpp
        local_tree_testcase.cpp
        testing_interface.cpp
)

set(HEADERS
        apparmor.h
        base_testcase.h
        daemon_testcase.h
        dbus_connection.h
        file_manager.h
        local_tree_testcase.h
        matchers.h
        network_reply.h
        process.h
        process_factory.h
        request_factory.h
        testing_interface.h
        uuid_factory.h
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Test_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(${GMOCK_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/client)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)

add_library(${TARGET} STATIC
    ${HEADERS}
    ${SOURCES}
)

target_link_libraries(${TARGET}
    ${Qt5Core_LIBRARIES}
    ${Qt5Sql_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ${GMOCK_LIBRARIES}
    ${GTEST_BOTH_LIBRARIES}
    ldm-common
    ldm-priv-common
    lomiri-download-manager-common
    lomiri-download-manager-client
)

=== src/common/priv/CMakeLists.txt ===
set(TARGET ldm-priv-common)

set(SOURCES
	lomiri/transfers/base_daemon.cpp
	lomiri/transfers/base_manager.cpp
	lomiri/transfers/i18n.cpp
	lomiri/transfers/queue.cpp
	lomiri/transfers/transfer.cpp
	lomiri/transfers/system/apn_proxy.cpp
	lomiri/transfers/system/apn_request_factory.cpp
	lomiri/transfers/system/apparmor.cpp
	lomiri/transfers/system/application.cpp
	lomiri/transfers/system/cryptographic_hash.cpp
	lomiri/transfers/system/dbus_proxy.cpp
	lomiri/transfers/system/dbus_proxy_factory.cpp
	lomiri/transfers/system/file_manager.cpp
	lomiri/transfers/system/filename_mutex.cpp
	lomiri/transfers/system/network_reply.cpp
	lomiri/transfers/system/network_session.cpp
	lomiri/transfers/system/nm_interface.cpp
	lomiri/transfers/system/process.cpp
	lomiri/transfers/system/process_factory.cpp
	lomiri/transfers/system/request_factory.cpp
	lomiri/transfers/system/timer.cpp
	lomiri/transfers/system/uuid_factory.cpp
	lomiri/transfers/system/uuid_utils.cpp
)

set(HEADERS
	lomiri/transfers/adaptor_factory.h
	lomiri/transfers/base_daemon.h
	lomiri/transfers/base_manager.h
	lomiri/transfers/i18n.h
	lomiri/transfers/manager_factory.h
	lomiri/transfers/queue.h
	lomiri/transfers/transfer.h
	lomiri/transfers/system/apn_proxy.h
	lomiri/transfers/system/apn_request_factory.h
	lomiri/transfers/system/apparmor.h
	lomiri/transfers/system/application.h
	lomiri/transfers/system/cryptographic_hash.h
	lomiri/transfers/system/dbus_proxy.h
	lomiri/transfers/system/dbus_proxy_factory.h
	lomiri/transfers/system/file_manager.h
	lomiri/transfers/system/filename_mutex.h
	lomiri/transfers/system/network_reply.h
	lomiri/transfers/system/network_session.h
	lomiri/transfers/system/nm_interface.h
	lomiri/transfers/system/pending_reply.h
	lomiri/transfers/system/process.h
	lomiri/transfers/system/process_factory.h
	lomiri/transfers/system/request_factory.h
	lomiri/transfers/system/timer.h
	lomiri/transfers/system/uuid_factory.h
	lomiri/transfers/system/uuid_utils.h
)

include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)

add_library(${TARGET} SHARED
	${HEADERS}
	${SOURCES}
)

set_target_properties(
	${TARGET}

	PROPERTIES
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	${LOMIRI_API_LDFLAGS}
	${GLOG_LIBRARIES}
	${Qt5Network_LIBRARIES}
	${Qt5Sql_LIBRARIES}
	${Qt5Core_LIBRARIES}
	${Qt5DBus_LIBRARIES}
	ldm-common
)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/common/public/CMakeLists.txt ===
set(TARGET ldm-common)

set(SOURCES
	lomiri/transfers/metadata.cpp
	lomiri/transfers/errors/auth_error_struct.cpp
	lomiri/transfers/errors/hash_error_struct.cpp
	lomiri/transfers/errors/http_error_struct.cpp
	lomiri/transfers/errors/network_error_struct.cpp
	lomiri/transfers/errors/process_error_struct.cpp
	lomiri/transfers/system/dbus_connection.cpp
	lomiri/transfers/system/hash_algorithm.cpp
	lomiri/transfers/system/logger.cpp
)

set(TRANSFERS_PUBLIC_HEADERS
	lomiri/transfers/metadata.h
	lomiri/transfers/visibility.h
)

set(ERRORS_PUBLIC_HEADERS
	lomiri/transfers/errors/auth_error_struct.h
	lomiri/transfers/errors/hash_error_struct.h
	lomiri/transfers/errors/http_error_struct.h
	lomiri/transfers/errors/network_error_struct.h
	lomiri/transfers/errors/process_error_struct.h
)

set(PRIVATE_HEADERS
	lomiri/transfers/system/dbus_connection.h
	lomiri/transfers/system/hash_algorithm.h
	lomiri/transfers/system/logger.h
)

include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})

add_library(${TARGET} SHARED
	${SOURCES}
	${TRANSFERS_PUBLIC_HEADERS}
	${ERRORS_PUBLIC_HEADERS}
	${PRIVATE_HEADERS}
)

set(symbol_map "${CMAKE_SOURCE_DIR}/src/common/public/symbols.map")
set_target_properties(
	${TARGET}

	PROPERTIES
        LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
	${Qt5DBus_LIBRARIES}
	${Qt5Network_LIBRARIES}
)

configure_file(${TARGET}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/pkgconfig)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${TRANSFERS_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/transfers)
install(FILES ${ERRORS_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/transfers/errors)

=== src/downloads/daemon/CMakeLists.txt ===
set(TARGET lomiri-download-manager)

set(SOURCES
	main.cpp
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)

add_executable(${TARGET}
	${SOURCES}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
	${Qt5Core_LIBRARIES}
	ldm-common
	ldm-priv-common
	lomiri-download-manager-common
	lomiri-download-manager-priv
)

install(FILES ${TARGET}.service DESTINATION
   	${CMAKE_INSTALL_DATADIR}/dbus-1/services)
install(FILES "com.lomiri.applications.Downloader.service" DESTINATION
   	/usr/share/dbus-1/system-services)
install(FILES "com.lomiri.applications.Downloader.conf" DESTINATION
   	/etc/dbus-1/system.d)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/downloads/priv/CMakeLists.txt ===
set(TARGET lomiri-download-manager-priv)

set(SOURCES
	lomiri/downloads/daemon.cpp
	lomiri/downloads/download.cpp
	lomiri/downloads/download_adaptor.cpp
	lomiri/downloads/download_adaptor_factory.cpp
	lomiri/downloads/download_manager_adaptor.cpp
	lomiri/downloads/download_manager_factory.cpp
	lomiri/downloads/downloads_db.cpp
	lomiri/downloads/factory.cpp
	lomiri/downloads/file_download.cpp
	lomiri/downloads/group_download.cpp
	lomiri/downloads/group_download_adaptor.cpp
	lomiri/downloads/header_parser.cpp
	lomiri/downloads/manager.cpp
	lomiri/downloads/mms_file_download.cpp
	lomiri/downloads/sm_file_download.cpp
	lomiri/downloads/state_machines/download_sm.cpp
	lomiri/downloads/state_machines/final_state.cpp
	lomiri/downloads/state_machines/state.cpp
)

set(HEADERS
	lomiri/downloads/daemon.h
	lomiri/downloads/download.h
	lomiri/downloads/download_adaptor.h
	lomiri/downloads/download_adaptor_factory.h
	lomiri/downloads/download_manager_adaptor.h
	lomiri/downloads/download_manager_factory.h
	lomiri/downloads/downloads_db.h
	lomiri/downloads/factory.h
	lomiri/downloads/file_download.h
	lomiri/downloads/group_download.h
	lomiri/downloads/group_download_adaptor.h
	lomiri/downloads/header_parser.h
	lomiri/downloads/manager.h
	lomiri/downloads/mms_file_download.h
	lomiri/downloads/sm_file_download.h
	lomiri/downloads/state_machines/download_sm.h
	lomiri/downloads/state_machines/final_state.h
	lomiri/downloads/state_machines/state.h
)

include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)

add_definitions(-DHELPER_DIR="${CMAKE_INSTALL_LIBEXECDIR}/lomiri-download-manager")

add_library(${TARGET} STATIC
	${HEADERS}
	${SOURCES}
)

set_target_properties(
	${TARGET}

	PROPERTIES
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
	${Qt5DBus_LIBRARIES}
	${Qt5Sql_LIBRARIES}
	ldm-common
	ldm-priv-common
	lomiri-download-manager-common
)

=== src/downloads/test-daemon/CMakeLists.txt ===
set(TARGET lomiri-download-manager-test-daemon)

set(SOURCES
	main.cpp
        testing_daemon.cpp
        testing_file_download.cpp
        testing_interface.cpp
        testing_manager.cpp
        testing_manager_adaptor.cpp
)

set(HEADERS
        testing_daemon.h
        testing_file_download.h
        testing_interface.h
        testing_manager.h
        testing_manager_adaptor.h
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)

add_executable(${TARGET}
	${SOURCES}
        ${HEADERS}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
        ${Qt5Core_LIBRARIES}
        ${Qt5DBus_LIBRARIES}
        ${Qt5Network_LIBRARIES}
	${Qt5Sql_LIBRARIES}
	ldm-common
	ldm-priv-common
	lomiri-download-manager-common
	lomiri-download-manager-priv
)

=== src/uploads/daemon/CMakeLists.txt ===
set(TARGET lomiri-upload-manager)

set(SOURCES
	main.cpp
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/uploads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/uploads/priv)

add_executable(${TARGET}
	${SOURCES}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
        ${Qt5Core_LIBRARIES}
	ldm-common
	ldm-priv-common
	lomiri-upload-manager-common
	lomiri-upload-manager-priv
)

install(FILES ${TARGET}.service DESTINATION
   	${CMAKE_INSTALL_DATADIR}/dbus-1/services)
install(FILES "com.lomiri.applications.Uploader.service" DESTINATION
   	/usr/share/dbus-1/system-services)
install(FILES "com.lomiri.applications.Uploader.conf" DESTINATION
   	/etc/dbus-1/system.d)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/uploads/priv/CMakeLists.txt ===
set(TARGET lomiri-upload-manager-priv)

set(SOURCES
        lomiri/uploads/daemon.cpp
        lomiri/uploads/factory.cpp
	lomiri/uploads/manager.cpp
        lomiri/uploads/file_upload.cpp
        lomiri/uploads/manager.cpp
        lomiri/uploads/mms_file_upload.cpp
        lomiri/uploads/upload_adaptor.cpp
        lomiri/uploads/upload_adaptor_factory.cpp
        lomiri/uploads/upload_manager_adaptor.cpp
        lomiri/uploads/upload_manager_factory.cpp
)

set(HEADERS
        lomiri/uploads/daemon.h
        lomiri/uploads/factory.h
	lomiri/uploads/manager.h
        lomiri/uploads/file_upload.h
        lomiri/uploads/manager.h
        lomiri/uploads/mms_file_upload.h
        lomiri/uploads/upload_adaptor.h
        lomiri/uploads/upload_adaptor_factory.h
        lomiri/uploads/upload_manager_adaptor.h
        lomiri/uploads/upload_manager_factory.h
)

include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/uploads/common)

add_library(${TARGET} STATIC
	${HEADERS}
	${SOURCES}
)

set_target_properties(
	${TARGET}

	PROPERTIES
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
	${Qt5DBus_LIBRARIES}
	${Qt5Sql_LIBRARIES}
	ldm-common
	ldm-priv-common
	lomiri-upload-manager-common
)

=== tests/downloads/client/CMakeLists.txt ===
# Copyright © 2014-2015 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Manuel de la Peña <manuel.delapena@canonical.com>


set(CLIENT_TESTS
    test_client_download
    test_download_manager_watch
    test_download_watch
    test_client_manager
    test_group_manager_watch
)

foreach(test ${CLIENT_TESTS})
        # set the sources per test
        set(${test}_CLIENT_SOURCES
                ${test}.cpp
        )

        set(${test}_CLIENT_HEADERS
                ${test}.h
        )

endforeach(test)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Test_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(${GMOCK_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/client)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)
include_directories(${CMAKE_SOURCE_DIR}/tests/common)

find_program(DBUS_RUNNER dbus-test-runner)

set(CLIENT_TESTS_LIBS
    ${Qt5Network_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ldm-common
    ldm-priv-common
    lomiri-download-manager-common
    lomiri-download-manager-client
    lomiri-download-manager-priv
    lomiri-download-manager-test-lib
)

if(DBUS_RUNNER)
        foreach(test ${CLIENT_TESTS})
                # set targets, linked libs and test
                add_executable(${test}_client
                        ${${test}_CLIENT_SOURCES}
                        ${${test}_CLIENT_HEADERS}
                )

                target_link_libraries(${test}_client
                        ${CLIENT_TESTS_LIBS}
                )

                ADD_TEST(NAME client_${test} COMMAND dbus-test-runner -m 360 --task=${CMAKE_CURRENT_BINARY_DIR}/${test}_client -c)

        endforeach(test)
else(DBUS_RUNNER)
        message(WARNING "dbus-test-runner binary not found tests will be disabled")
endif(DBUS_RUNNER)

=== tests/downloads/daemon/CMakeLists.txt ===
# Copyright © 2014-2015 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Manuel de la Peña <manuel.delapena@canonical.com>

set(DAEMON_TESTS
        test_apn_request_factory
        test_apparmor
        test_base_download
        test_cancel_download_transition
        test_daemon
        test_download
        test_download_factory
        test_download_manager
        test_downloads_db
        test_file_download_sm
        test_filename_mutex
        test_final_state
        test_group_download
        test_metadata
        test_mms_download
        test_network_error_transition
        test_resume_download_transition
        test_ssl_error_transition
        test_start_download_transition
        test_stop_request_transition
        test_transfers_queue
)

foreach(test ${DAEMON_TESTS})
        # set the sources per test
        set(${test}_DAEMON_SOURCES
                ${test}.cpp
        )

        set(${test}_DAEMON_HEADERS
                application.h
                cryptographic_hash.h
                database.h
                dbus_proxy.h
                dbus_proxy_factory.h
                download.h
                factory.h
                filename_mutex.h
                group_download.h
                manager.h
                pending_reply.h
                queue.h
                sm_file_download.h
                timer.h
                transfer.h
                ${test}.h
        )

endforeach(test)


include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Test_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(${GMOCK_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/client)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)
include_directories(${CMAKE_SOURCE_DIR}/tests/common)

set(DAEMON_TESTS_LIBS
        ${Qt5Core_LIBRARIES}
        ${Qt5Sql_LIBRARIES}
        ${Qt5DBus_LIBRARIES}
        ${Qt5Test_LIBRARIES}
        ${GMOCK_LIBRARY}
        ${GTEST_BOTH_LIBRARIES}
        ldm-common
        ldm-priv-common
        lomiri-download-manager-common
        lomiri-download-manager-priv
        lomiri-download-manager-test-lib
)


foreach(test ${DAEMON_TESTS})
        # set targets, linked libs and test
        add_executable(${test}_daemon
                ${${test}_DAEMON_SOURCES}
                ${${test}_DAEMON_HEADERS}
        )

        target_link_libraries(${test}_daemon
                ${DAEMON_TESTS_LIBS}
        )


ADD_TEST(NAME daemon_${test} COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${test}_daemon)
endforeach(test)

=== tests/downloads/qml/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Manuel de la Peña <manuel.delapena@canonical.com>

set(QML_TESTS
    test_single_download
    test_metadata
)

foreach(test ${QML_TESTS})
    # set the sources per test
    set(${test}_QML_SOURCES
            ${test}.cpp
    )

    set(${test}_QML_HEADERS
        download.h
        error.h
        manager.h
        testable_single_download.h
        ${test}.h
    )

endforeach(test)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Test_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(${GMOCK_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/client)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/qml)
include_directories(${CMAKE_SOURCE_DIR}/tests/common)

set(QML_TESTS_LIBS
    ${Qt5Core_LIBRARIES}
    ${Qt5Sql_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ${GMOCK_LIBRARY}
    ${GTEST_BOTH_LIBRARIES}
    ldm-common
    lomiri-download-manager-common
    lomiri-download-manager-test-lib
    LomiriDownloadManager
)

find_program(XVFB xvfb-run)

if(XVFB)
    set(XVFB_CMD xvfb-run -a -s "-screen 0 540x960x24")

    foreach(test ${QML_TESTS})
        # set targets, linked libs and test
        add_executable(${test}_qml
            ${${test}_QML_SOURCES}
            ${${test}_QML_HEADERS}
        )

        target_link_libraries(${test}_qml
            ${QML_TESTS_LIBS}
        )


    ADD_TEST(NAME qml_${test} COMMAND ${XVFB_CMD} ${CMAKE_CURRENT_BINARY_DIR}/${test}_qml)
    endforeach(test)
else(XVFB)
        message(WARNING "xvfb-run binary not found: qml tests will be disabled")
endif(XVFB)

=== debian/changelog ===
lomiri-download-manager (0.1.1-2) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/: Update upstream Git repo URL.

  [ Anton Gladky ]
  * Add debian/.gitlab-ci.yml

  [ Marius Gripsgard ]
  * [debian/*.symbols] Mark unused symbols that would otherwise be optimized out

 -- Marius Gripsgard <marius@ubports.com>  Sat, 07 Jan 2023 15:35:37 +0100

lomiri-download-manager (0.1.1-1) unstable; urgency=medium

  * Upstream release 0.1.1
  * debian/ldm.install: Systemd user job has been removed upstream (v 0.1.1)
  * debian/*.install: Rename files to match upstream release (v 0.1.1)
  * debian/control: Update B-D to match upstream release (v 0.1.1)
  * debian/control: Add xauth to B-D, needed for tests
  * debian/patches: Remove upstreamed patches
     - 1001_typo-fixes.patch
     - 1002_doxygen-relative-paths.patch
  * debian/patches: Refresh patches
     - 2001_build-without-Werror.patch
  * debian/copyright: Update copyright to match new upstream release
  * debian/control: Add myself to uploaders

 -- Marius Gripsgard <marius@ubports.com>  Fri, 17 Jun 2022 11:50:21 +0200

=== debian/control ===
Source: lomiri-download-manager
Section: net
Priority: optional
Build-Depends: cmake,
               cmake-extras (>= 1.5-7~),
               debhelper-compat (= 12),
               dh-apparmor,
               doxygen,
               dbus-test-runner,
               googletest,
               graphviz,
               qtbase5-dev,
               libboost-log-dev,
               libboost-program-options-dev,
               libdbus-1-dev,
               libqt5sql5-sqlite,
               liblomiri-api-dev (>= 0.1.1),
               libgoogle-glog-dev,
               libgtest-dev (>= 1.10.0.20201025-1~),
               pkg-config,
               python3,
               qml-module-qttest,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qttools5-dev-tools,
               network-manager,
               rdfind,
               symlinks,
               pkg-kde-tools,
               xvfb,
               xauth,
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <marius@ubports.com>,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-download-manager/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-download-manager.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-download-manager/

Package: libldm-common0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Upload/Download Manager - shared library
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes the common shared library, shared between the
 client lib and the service lib.

Package: libldm-common-dev
Section: libdevel
Architecture: any
Depends: libldm-common0 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Lomiri Upload/Download Manager - development files
 Lomiri Uploadi/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the common headers, shared between the client
 library and the daemon library.

Package: libldm-priv-common0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
Description: Lomiri Upload/Download Manager - shared private library
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes an auxiliary shared (but private) library.

Package: liblomiri-download-manager-common0
Section: libs
Architecture: any
Depends: libldm-common0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QT library for Lomiri Download Manager - common shared library
 Lomiri Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes the common shared library between the client lib
 and the service lib.

Package: liblomiri-download-manager-common-dev
Section: libdevel
Architecture: any
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-download-manager-common0 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: QT library for Lomiri Download Manager - common development files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the common headers shared between the client
 library and the daemon library.

Package: liblomiri-download-manager-client0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
         liblomiri-download-manager-common0 (= ${binary:Version}),
Description: QT library for Lomiri Download Manager - shared client library
 Lomiri Download Manager performs downloads from a centralized location.
 .
 This package includes the public shared library providing the API
 for implementing a service client.

Package: liblomiri-download-manager-client-dev
Section: libdevel
Architecture: any
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-download-manager-common-dev (= ${binary:Version}),
         liblomiri-download-manager-client0 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: lomiri-download-manager-client-dev
Replaces: lomiri-download-manager-client-dev
Description: QT library for Lomiri Download Manager - client development files
 Lomiri Download Manager performs downloads from a centralized location.
 .
 This package contains the header that can be used to allow an
 application use the Lomiri Download Manager client library.

Package: liblomiri-download-manager-client-doc
Section: doc
Architecture: all
Depends: liblomiri-download-manager-client-dev (>= ${source:Version}),
          ${misc:Depends},
Description: QT library for Lomiri Download Manager - client documentation files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 Documentation files for the LDM client development.

Package: liblomiri-upload-manager-common0
Section: libs
Architecture: any
Depends: libldm-common0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QT library for Lomiri Upload Manager - shared common library
 Lomiri Upload Manager performs uploads from a centralized location.
 .
 This package includes the common shared library between the client lib
 and the service lib.

Package: liblomiri-upload-manager-common-dev
Section: libdevel
Architecture: any
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-upload-manager-common0 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: QT library for Lomiri Upload Manager - common development files
 Lomiri Upload Manager performs uploads from a centralized location.
 .
 This package contains the common headers shared between the client
 library and the daemon library.

Package: lomiri-download-manager
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
         libldm-priv-common0 (= ${binary:Version}),
         liblomiri-download-manager-common0 (= ${binary:Version}),
         unzip
Suggests: apparmor
Description: Lomiri Download Manager - daemon
 Lomiri Download Manager performs downloads from a centralized
 location.
 .
 This package includes the Lomiri Download Manager user space daemon.

Package: lomiri-upload-manager
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
         libldm-priv-common0 (= ${binary:Version}),
         liblomiri-upload-manager-common0 (= ${binary:Version}),
Description: Lomiri Upload Manager - daemon
 Lomiri Upload Manager performs uploads from a centralized
 location.
 .
 This package includes the Lomiri Upload Manager user space daemon.

Package: qml-module-lomiri-downloadmanager
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
         liblomiri-download-manager-common0 (= ${binary:Version}),
         liblomiri-download-manager-client0 (= ${binary:Version}),
         lomiri-download-manager (= ${binary:Version})
Description: Lomiri Download Manager QML Plugin
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains a QML Plugin to handle downloads from a pure QML
 application, without the need to write any C++ code.

Package: qml-module-lomiri-downloadmanager-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: Lomiri Download Manager QML Plugin - documentation files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the documentation of the Lomiri DownloadManager
 QML Plugin.
